<?php
namespace kwy\sunmi;

class SunmiApi{
    use MD5Sign;
	
    ##测试key   60de91d41b17bdbb5dd970c10
    ##正式key   da3cd78035da6f6c2bdfccfd9
	private $key='da3cd78035da6f6c2bdfccfd9';
	private $channel_code='180010';
	private $env='pro';
	private $hosts=[
	    'test'=>'http://test.webapi.engine.sunmi.com',#测试
	    'pro'=>'http://webapi.engine.sunmi.com',#生产
	    'prepro'=>'http://uat.webapi.engine.sunmi.com',#预发布
	];
	
	private $api_req_time=0;
	
	public function __construct($env,$channel_code,$key){
	    $this->env=$env;
	    $this->channel_code=$channel_code;
	    $this->key=$key;
	}
	
	public function request($function,$biz_params){
	    $postData=array_merge([
	        'channel_code'=>$this->channel_code,
	        'timestamp'=>time(),
	        'request_number'=>time().rand(10000,99999),
	    ],$biz_params);
		$postData['sign']=$this->getSign($postData,$this->key);
		$url=$this->hosts[$this->env].$function;
		$ret=$this->post($url, $postData);
		if ($ret['code']!=0){
			throw new \Exception($ret['message'],$ret['code']);
		}
		return $ret;
	}
	
	private function post($url,$data){
		$begin_time=microtime(true);
		$ch=curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);//url
		curl_setopt($ch, CURLOPT_POST, 1);//post
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);//返回结果curl
		curl_setopt($ch, CURLOPT_IPRESOLVE, CURL_IPRESOLVE_V4 );//强制ipv4解析
		curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
		curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,0);      //忽略校验证书
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 2);
		$ret = curl_exec($ch);
		$this->api_req_time=microtime(true)-$begin_time;
		if ($ret===false){
			throw new \Exception(curl_error($ch),curl_errno($ch));
		}
		$arr_ret=json_decode($ret,true);
		return $arr_ret;
	}
	
	
	public function getApiRequstTime(){
		return $this->api_req_time;
	}
	
	
	
	
}