<?php
/**
 *
 * Auther: heyu
 * DateTime: 2020-01-08 16:31
 *
 */

namespace kwy\sunmi\device;


use kwy\sunmi\lib\ApiRequest;

class PassengerFlow extends ApiRequest
{

    /**
     * 获取当日实时人流量(实时总人流量)
     * @author heyu 2020-01-08 16:34
     * @param $shop_id
     * @throws \Exception  "invalid saas shop info"
     * @return int
     */
    public function getTodayLatest($shop_id){
        $api='/passengerFlow/stat/today/getLatest';
        $param=[
            'shop_id'=>$shop_id,
        ];
        $result = $this->request($api,$param);
        if ($result['code']==0){
            return $result['data']['count'];
        }else{
            throw new \Exception($result['msg']);
        }
    }
}