<?php
/**
 *
 * Auther: heyu
 * DateTime: 2020-01-08 15:32
 *
 */

namespace kwy\sunmi\lib;


use kwy\sunmi\MD5Sign;
use kwy\sunmi\product\Config;
use kwy\sunmi\Util;
use kwy\util\http\CurlHttp;

class ApiRequest
{
    use MD5Sign;

    /** @var CurlHttp */
    private $http;

    /**
     * @return CurlHttp
     */
    public function getHttp()
    {
        if (empty($this->http)){
            $this->http=new CurlHttp();
        }
        return $this->http;
    }

    /**
     * @param CurlHttp $http
     */
    public function setHttp($http)
    {
        $this->http = $http;
    }



    protected function request($api,$param){

        $reqParam=[
            'app_id'=>Config::$app_id,
            'random'=>Util::getNonceStr(),
            'timestamp'=>time(),
        ];

        $reqParam=array_merge($reqParam,$param);
        $reqParam['sign']=$this->getSign($reqParam,Config::$secret_key);
        $url=Config::getHost().$api;

        $http=$this->getHttp();
        $http->setUrl($url);
        $http->setResponseType('array');
        return $http->post($reqParam);
    }
}