<?php
/**
 *
 * Auther: heyu
 * DateTime: 2019-08-28 10:14
 *
 */

namespace kwy\sunmi\product;


/**
 * Class Product
 * @package kwy\sunmi\product
 * @property string $id
 * @property string $seq_num
 * @property string $bar_code
 * @property string $name
 * @property string $alias
 * @property double $price 当前售价
 * @property string $promote_price 促销价
 * @property string $member_price 会员价
 * @property string $spec 规格信息
 * @property string $unit 商品单位
 * @property string $level 等级
 * @property string $area 产地
 * @property string $brand 品牌
 * @property string $qr_code 二维码
 * @property int $expire_time 有效期
 */
class Product
{

    private $data=[];

    public function __set($name, $value)
    {
        $this->data[$name]=$value;
    }

    public function __get($name)
    {
        if (isset($this->data[$name])){
            return $this->data[$name];
        }else{
            return null;
        }
    }

    public function toArray(){
        return $this->data;
    }


}