<?php
/**
 * Created by PhpStorm.
 * User: heyu
 * Date: 2019-05-08
 * Time: 09:45
 */

namespace kwy\sunmi\test;

use kwy\sunmi\pay\SunmiPay;
use PHPUnit\Framework\TestCase;

class SunmiPayTest extends TestCase
{
    /**
     * 测试查单
     * @throws \Exception
     */
    public function testQuery(){
        $obj=new SunmiPay();
        $result=$obj->query('TL05D91940002','C89CAAC653066E4CD2AE1D');
        $this->assertArrayHasKey('merchant_order_no',$result);
        $this->assertArrayHasKey('status',$result);
        $this->assertEquals(3,$result['status']);

        $result=$obj->query('TL05D91940002','CD7F4778EAD5AF025DCC5B');
        var_dump($result);
        $this->assertArrayHasKey('merchant_order_no',$result);
        $this->assertArrayHasKey('status',$result);
        $this->assertEquals(3,$result['status']);


    }

    /**
     * 测试退款
     * @throws \Exception
     */
    public function testRefund(){
        $obj=new SunmiPay();

        $result=$obj->refund('TL05D91940002',1,'CD7F4778EAD5AF025DCC5B','test_'.date('ymdHis').rand(10000,9999));
        var_dump($result);
        $this->assertArrayHasKey('state',$result,'测试返回包含stat字段');
        $this->assertEquals(3,$result['state']);
        $this->assertArrayHasKey('orig_merchant_order_no',$result);
        //$this->assertEquals('PSMM201905081437177483',$result['orig_merchant_order_no']);
    }
}